//Done by Manar Mahmalji and Karel Tempelaere
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
// Define pressure sensors pins:
#define pr_sens1 A0
#define pr_sens2 A1
#define pr_sens3 A2

//Define variable to store sensor readings:
int read_sens1;// gripper finger 
int read_sens2;// gripper finger
int read_sens3;// gripper finger
int max_reading;
// Set the LCD address to 0x27 for a 16 chars and 2 line display
LiquidCrystal_I2C lcd(0x27, 16, 2);

// linear potentiometer variables
int potValue;
int max_limit;
int min_limit;// to be calibrated
// push buttons and motor pins
int motor1pin1 = 2;
int motor1pin2 = 3;
int speedpin=9;
const int buttonPin1 = 7;
const int buttonPin2 =  8;
int buttonState1=0;
int buttonState2=0;// Buttons being unpressed is the natural case


void setup() {

  // initialize the LCD
	lcd.begin();
	// Turn on the blacklight and print a message.
	lcd.backlight();

  pinMode(motor1pin1, OUTPUT);
  pinMode(motor1pin2, OUTPUT);
  pinMode(speedpin,OUTPUT);
  pinMode(buttonPin1, INPUT);
  pinMode(buttonPin2, INPUT);
}


void loop() {
  
//reading push buttons
buttonState1 = digitalRead(buttonPin1);
buttonState2 = digitalRead(buttonPin2);


if (buttonState1 == HIGH && buttonState2 == LOW)// we'll have to test it to know direction
  {
    analogWrite(speedpin,255);
  digitalWrite(motor1pin1, HIGH);
  digitalWrite(motor1pin2, LOW);

  }
 
 if (buttonState1 == LOW && buttonState2 == HIGH)
  {
    analogWrite(speedpin,255);
   digitalWrite(motor1pin1, LOW);
   digitalWrite(motor1pin2, HIGH);
  }
  
  if ((buttonState1 == HIGH && buttonState2 == HIGH )||(buttonState1 == LOW && buttonState2 == LOW))
  // if ( no button is pressed or both buttons are pressed
  {
    //motor brake
  analogWrite(speedpin,255);
   digitalWrite(motor1pin1, LOW);
   digitalWrite(motor1pin2, LOW);
  }
 
  
  
  //reading pressure sesnors 
  lcd.clear();
  lcd.setCursor (0,0);
  // Read the pressure sensors
  read_sens1 = analogRead(pr_sens1);
  read_sens2 = analogRead(pr_sens2);
  read_sens3 = analogRead(pr_sens3);
  
  // Print the max of pressure readings from sensors 1 ,2 and 3 on the LCD screen:
  
    max_reading=max3(read_sens1,read_sens2,read_sens3);
  
     
     lcd.setCursor (0,0);

    if (max_reading < 10) {
    lcd.print("No pressure");
  } else if (max_reading  < 200) { 
    lcd.print("Light(4kg)");
  } else if (max_reading < 400) {
    lcd.print("Bit heavy(8kg)");
  } else if (max_reading  < 600) {
    lcd.print("Medium(12kg)");
  } else {
    lcd.print("Heavy(20kg)");
  }
  


  
  // reading linear potentiometer
   potValue = analogRead(A3);
  delay(1);
  // delay in between reads for stability
  if(potValue>max_limit || potValue<min_limit)
  {
    //brake motor
    analogWrite(speedpin,100);
   digitalWrite(motor1pin1, LOW);
   digitalWrite(motor1pin2, LOW);
  }
  
}//



int max3(int a, int b, int c)
{
  int maxguess;

  maxguess = max(a,b);  // biggest of A and B
  maxguess = max(maxguess, c);  // but maybe C is bigger?

  return(maxguess);
}



